• Русский
  • MachineHealthCheck [cluster.x-k8s.io/v1beta1]

    Description
    MachineHealthCheck is the Schema for the machinehealthchecks API.
    Type
    object

    Specification

    PropertyTypeDescription
    apiVersionstring

    APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

    kindstring

    Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

    metadataObjectMeta

    ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

    specobject

    spec is the specification of machine health check policy

    statusobject

    status is the most recently observed status of MachineHealthCheck resource

    .spec

    Description
    spec is the specification of machine health check policy
    Type
    object
    Required
    clusterNameselector
    PropertyTypeDescription
    clusterNamestring

    clusterName is the name of the Cluster this object belongs to.

    maxUnhealthy

    maxUnhealthy specifies the maximum number of unhealthy machines allowed. Any further remediation is only allowed if at most "maxUnhealthy" machines selected by "selector" are not healthy.

    Deprecated: This field is deprecated and is going to be removed in the next apiVersion. Please see https://github.com/kubernetes-sigs/cluster-api/issues/10722 for more details.

    nodeStartupTimeoutstring

    nodeStartupTimeout allows to set the maximum time for MachineHealthCheck to consider a Machine unhealthy if a corresponding Node isn't associated through a Spec.ProviderID field.

    The duration set in this field is compared to the greatest of:

    • Cluster's infrastructure ready condition timestamp (if and when available)
    • Control Plane's initialized condition timestamp (if and when available)
    • Machine's infrastructure ready condition timestamp (if and when available)
    • Machine's metadata creation timestamp

    Defaults to 10 minutes. If you wish to disable this feature, set the value explicitly to 0.

    remediationTemplateobject

    remediationTemplate is a reference to a remediation template provided by an infrastructure provider.

    This field is completely optional, when filled, the MachineHealthCheck controller creates a new object from the template referenced and hands off remediation of the machine to a controller that lives outside of Cluster API.

    selectorobject

    selector is a label selector to match machines whose health will be exercised

    unhealthyConditionsarray

    unhealthyConditions contains a list of the conditions that determine whether a node is considered unhealthy. The conditions are combined in a logical OR, i.e. if any of the conditions is met, the node is unhealthy.

    unhealthyRangestring

    unhealthyRange specifies the range of unhealthy machines allowed. Any further remediation is only allowed if the number of machines selected by "selector" as not healthy is within the range of "unhealthyRange". Takes precedence over maxUnhealthy. Eg. "[3-5]" - This means that remediation will be allowed only when: (a) there are at least 3 unhealthy machines (and) (b) there are at most 5 unhealthy machines

    Deprecated: This field is deprecated and is going to be removed in the next apiVersion. Please see https://github.com/kubernetes-sigs/cluster-api/issues/10722 for more details.

    .spec.remediationTemplate

    Description
    remediationTemplate is a reference to a remediation template provided by an infrastructure provider. This field is completely optional, when filled, the MachineHealthCheck controller creates a new object from the template referenced and hands off remediation of the machine to a controller that lives outside of Cluster API.
    Type
    object
    PropertyTypeDescription
    apiVersionstring

    API version of the referent.

    fieldPathstring

    If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.

    kindstring

    Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

    namestring

    Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

    namespacestring

    Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

    resourceVersionstring

    Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

    uidstring

    UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids

    .spec.selector

    Description
    selector is a label selector to match machines whose health will be exercised
    Type
    object
    PropertyTypeDescription
    matchExpressionsarray

    matchExpressions is a list of label selector requirements. The requirements are ANDed.

    matchLabelsobject

    matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

    .spec.selector.matchExpressions

    Description
    matchExpressions is a list of label selector requirements. The requirements are ANDed.
    Type
    array

    .spec.selector.matchExpressions[]

    Description
    A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
    Type
    object
    Required
    keyoperator
    PropertyTypeDescription
    keystring

    key is the label key that the selector applies to.

    operatorstring

    operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

    valuesarray

    values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

    .spec.selector.matchExpressions[].values

    Description
    values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
    Type
    array

    .spec.selector.matchExpressions[].values[]

    Type
    string

    .spec.selector.matchLabels

    Description
    matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
    Type
    object

    .spec.unhealthyConditions

    Description
    unhealthyConditions contains a list of the conditions that determine whether a node is considered unhealthy. The conditions are combined in a logical OR, i.e. if any of the conditions is met, the node is unhealthy.
    Type
    array

    .spec.unhealthyConditions[]

    Description
    UnhealthyCondition represents a Node condition type and value with a timeout specified as a duration. When the named condition has been in the given status for at least the timeout value, a node is considered unhealthy.
    Type
    object
    Required
    statustimeouttype
    PropertyTypeDescription
    statusstring

    status of the condition, one of True, False, Unknown.

    timeoutstring

    timeout is the duration that a node must be in a given status for, after which the node is considered unhealthy. For example, with a value of "1h", the node must match the status for at least 1 hour before being considered unhealthy.

    typestring

    type of Node condition

    .status

    Description
    status is the most recently observed status of MachineHealthCheck resource
    Type
    object
    PropertyTypeDescription
    conditionsarray

    conditions defines current service state of the MachineHealthCheck.

    currentHealthyinteger

    currentHealthy is the total number of healthy machines counted by this machine health check

    expectedMachinesinteger

    expectedMachines is the total number of machines counted by this machine health check

    observedGenerationinteger

    observedGeneration is the latest generation observed by the controller.

    remediationsAllowedinteger

    remediationsAllowed is the number of further remediations allowed by this machine health check before maxUnhealthy short circuiting will be applied

    targetsarray

    targets shows the current list of machines the machine health check is watching

    v1beta2object

    v1beta2 groups all the fields that will be added or modified in MachineHealthCheck's status with the V1Beta2 version.

    .status.conditions

    Description
    conditions defines current service state of the MachineHealthCheck.
    Type
    array

    .status.conditions[]

    Description
    Condition defines an observation of a Cluster API resource operational state.
    Type
    object
    Required
    lastTransitionTimestatustype
    PropertyTypeDescription
    lastTransitionTimestring

    lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

    messagestring

    message is a human readable message indicating details about the transition. This field may be empty.

    reasonstring

    reason is the reason for the condition's last transition in CamelCase. The specific API may choose whether or not this field is considered a guaranteed API. This field may be empty.

    severitystring

    severity provides an explicit classification of Reason code, so the users or machines can immediately understand the current situation and act accordingly. The Severity field MUST be set only when Status=False.

    statusstring

    status of the condition, one of True, False, Unknown.

    typestring

    type of condition in CamelCase or in foo.example.com/CamelCase. Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important.

    .status.targets

    Description
    targets shows the current list of machines the machine health check is watching
    Type
    array

    .status.targets[]

    Type
    string

    .status.v1beta2

    Description
    v1beta2 groups all the fields that will be added or modified in MachineHealthCheck's status with the V1Beta2 version.
    Type
    object
    PropertyTypeDescription
    conditionsarray

    conditions represents the observations of a MachineHealthCheck's current state. Known condition types are RemediationAllowed, Paused.

    .status.v1beta2.conditions

    Description
    conditions represents the observations of a MachineHealthCheck's current state. Known condition types are RemediationAllowed, Paused.
    Type
    array

    .status.v1beta2.conditions[]

    Description
    Condition contains details for one aspect of the current state of this API Resource.
    Type
    object
    Required
    lastTransitionTimemessagereasonstatustype
    PropertyTypeDescription
    lastTransitionTimestring

    lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

    messagestring

    message is a human readable message indicating details about the transition. This may be an empty string.

    observedGenerationinteger

    observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.

    reasonstring

    reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.

    statusstring

    status of the condition, one of True, False, Unknown.

    typestring

    type of condition in CamelCase or in foo.example.com/CamelCase.

    API Endpoints

    The following API endpoints are available:

    • /apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinehealthchecks
      • DELETE: delete collection of MachineHealthCheck
      • GET: list objects of kind MachineHealthCheck
      • POST: create a new MachineHealthCheck
    • /apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinehealthchecks/{name}
      • DELETE: delete the specified MachineHealthCheck
      • GET: read the specified MachineHealthCheck
      • PATCH: partially update the specified MachineHealthCheck
      • PUT: replace the specified MachineHealthCheck
    • /apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinehealthchecks/{name}/status
      • GET: read status of the specified MachineHealthCheck
      • PATCH: partially update status of the specified MachineHealthCheck
      • PUT: replace status of the specified MachineHealthCheck

    /apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinehealthchecks

    HTTP method
    DELETE
    Description
    delete collection of MachineHealthCheck
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    list objects of kind MachineHealthCheck
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheckList schema
    401 - UnauthorizedEmpty
    HTTP method
    POST
    Description
    create a new MachineHealthCheck
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyMachineHealthCheck schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheck schema
    201 - CreatedMachineHealthCheck schema
    202 - AcceptedMachineHealthCheck schema
    401 - UnauthorizedEmpty

    /apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinehealthchecks/{name}

    HTTP method
    DELETE
    Description
    delete the specified MachineHealthCheck
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    202 - AcceptedStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    read the specified MachineHealthCheck
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheck schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update the specified MachineHealthCheck
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheck schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace the specified MachineHealthCheck
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyMachineHealthCheck schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheck schema
    201 - CreatedMachineHealthCheck schema
    401 - UnauthorizedEmpty

    /apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinehealthchecks/{name}/status

    HTTP method
    GET
    Description
    read status of the specified MachineHealthCheck
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheck schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update status of the specified MachineHealthCheck
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheck schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace status of the specified MachineHealthCheck
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyMachineHealthCheck schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKMachineHealthCheck schema
    201 - CreatedMachineHealthCheck schema
    401 - UnauthorizedEmpty